Description

As a support for OpenScap reports and other future types of reports, we need to add a global status to hosts.

Host will have one generic overall status (error, warning, ok) and it's transitions will be caused by other specific statuses. Statuses

(e.g. puppet status) will be extracted to separate entity and will be

changed when puppet report is imported (by PuppetReportImporter). This means we need a way to register new report types and

importers from plugin (exactly the same we have for facts now). Reports will probably only differ in metrics and their own statuses,

therefore we should make metrics optional and mapping to global status should be different per specific status.

User stories:

- As a developer I want to have global host state with developer API allowing me to change it easily.

- As a developer I want to register new host status type and define mapping between it and host global state.

- As a user I want to be able to search based on host global status.

- As a user I want to see the overall host status derived from all report types statuses.

Related issues:

Related to Foreman - Feature #4151: Add STI to reports and allow for register... Closed 01/21/2014

Related to Salt - Feature #11699: Use new ConfigurationStatus for Salt report... Closed 09/04/2015

Related to Foreman - Bug #11704: Configuration no report appears as "green" icon Closed 09/06/2015

Related to Foreman - Bug #11707: Unmanaged host detail status table is broken Closed 09/07/2015

Related to Discovery - Bug #11708: New status code broke discovery plugin API Closed 09/07/2015

Related to Discovery - Feature #11710: Use global status for Discovery New 09/07/2015

Related to Foreman - Bug #11771: Saving host without particular status fails Closed 09/10/2015

Related to Foreman - Bug #11834: host status migration is very slow Closed 09/15/2015

Related to Foreman - Bug #11835: db migration fail on report status Closed 09/15/2015

Related to OpenSCAP - Feature #11872: Add a compliance status using Foreman 1... Closed 09/17/2015

Related to Foreman - Feature #12213: Support for preferring a particular host... New 10/19/2015

Related to Foreman - Bug #13456: Different Icon for Pending changes ? New 01/28/2016

Related to Foreman - Bug #13939: API v1 hosts rabl references deprecated pupp... Closed 02/29/2016

Related to Foreman - Bug #14501: Global status icon does not indicate active ... New 04/06/2016

Related to Foreman - Bug #15213: DHCP conflict detection fails with exception... Closed

Related to Foreman - Bug #15362: Global status audit display status numbers i... Closed 06/09/2016

Related to Foreman - Refactor #15849: Improve performance of host global stat... New 07/27/2016

Related to Foreman - Bug #17897: Response of the api to get host status in th... Closed 01/03/2017

Related to Foreman - Refactor #28585: drop deprecated host status endpoint Closed

Associated revisions

Revision e54016da - 09/04/2015 08:03 AM - Marek Hulán

Fixes #10782 - global host status

Introduce new global host status that is composed of host substatuses.
Each substatus defines a mapping to the global one which can result in

three values

OK

WARN

ERROR

Plugins can add their own substatuses. These are automatically

propagated also to API.

Thanks to Tomas Strachota who wrote the original code.

Revision fcbb4061 - 01/18/2016 10:12 AM - Marek Hulán

Refs #10782 - document Foreman statuses

Revision 424e0afe - 01/18/2016 10:14 AM - Dominic Cleal 

Merge pull request #515 from ares/statuses

Refs #10782 - document Foreman statuses

History

#1 - 06/11/2015 07:07 AM - Tomáš Strachota

- Related to Feature #4151: Add STI to reports and allow for registering new report types added

#2 - 07/28/2015 04:27 AM - The Foreman Bot

- Status changed from Assigned to Ready For Testing

- Pull request https://github.com/theforeman/foreman/pull/2580 added

- Pull request deleted ()

#3 - 09/04/2015 08:03 AM - Dominic Cleal

- Assignee changed from Tomáš Strachota to Marek Hulán

- translation missing: en.field_release set to 63

#4 - 09/04/2015 09:01 AM - Marek Hulán

- Status changed from Ready For Testing to Closed

- % Done changed from 0 to 100

Applied in changeset e54016da688f5f91f52dfc68b33bd4e3275e6cac.

#5 - 09/04/2015 11:17 AM - Stephen Benjamin

- Related to Feature #11699: Use new ConfigurationStatus for Salt report importing added

#6 - 09/06/2015 07:01 AM - Ohad Levy

- Related to Bug #11704: Configuration no report appears as "green" icon added

#7 - 09/07/2015 06:01 AM - Lukas Zapletal

- Related to Bug #11707: Unmanaged host detail status table is broken added

#8 - 09/07/2015 06:01 AM - Lukas Zapletal

- Related to Bug #11708: New status code broke discovery plugin API added

#9 - 09/07/2015 06:56 AM - Lukas Zapletal

- Related to Feature #11710: Use global status for Discovery added

#10 - 09/10/2015 11:00 AM - Dominic Cleal

- Related to Bug #11771: Saving host without particular status fails added

#11 - 09/15/2015 01:37 PM - Ohad Levy

- Related to Bug #11834: host status migration is very slow added

05/11/2024 2/3

https://projects.theforeman.org/projects/foreman/repository/foreman/revisions/e54016da688f5f91f52dfc68b33bd4e3275e6cac


#12 - 09/15/2015 01:39 PM - Ohad Levy

- Related to Bug #11835: db migration fail on report status added

#13 - 09/17/2015 11:05 AM - Marek Hulán

- Related to Feature #11872: Add a compliance status using Foreman 1.10 API added

#14 - 10/19/2015 10:37 AM - Greg Sutcliffe

- Related to Feature #12213: Support for preferring a particular host status in the global view added

#15 - 01/29/2016 03:25 AM - Dominic Cleal

- Related to Bug #13456: Different Icon for Pending changes ? added

#16 - 02/29/2016 03:56 AM - Dominic Cleal

- Related to Bug #13939: API v1 hosts rabl references deprecated puppet_status call added

#17 - 04/06/2016 05:20 AM - Dominic Cleal

- Related to Bug #14501: Global status icon does not indicate active or pending configuration status added

#18 - 05/30/2016 08:12 AM - Marek Hulán

- Related to Bug #15213: DHCP conflict detection fails with exception if proxy is unavailable added

#19 - 06/09/2016 08:10 AM - Marek Hulán

- Related to Bug #15362: Global status audit display status numbers instead of label added

#20 - 07/27/2016 04:36 AM - Tomer Brisker

- Related to Refactor #15849: Improve performance of host global status updates added

#21 - 04/12/2017 07:34 AM - Marek Hulán

- Related to Bug #17897: Response of the api to get host status in the apidoc is incorrect with the actuals added

#22 - 12/29/2019 03:04 PM - Tomer Brisker

- Related to Refactor #28585: drop deprecated host status endpoint added
